//+------------------------------------------------------------------+
//|                                            20/200 expert v3.mq4  |
//|                                                    1H   EUR/USD  |
//|                                                    Smirnov Pavel |
//|                                                 www.autoforex.ru |
//+------------------------------------------------------------------+

#property copyright "Smirnov Pavel"
#property link      "www.autoforex.ru"

extern int Leverage =10;
extern int TakeProfit_L = 40; // Tru~ uz{y r ~{p
extern int StopLoss_L = 133;  // ru~ | r ~{p
extern int TakeProfit_S = 27; // Tru~ uz{y r ~{p
extern int StopLoss_S = 200;  // ru~ | r ~{p
extern int TradeTime=18;      // Bu} rtp r ~{
extern int t1=7;
extern int t2=2;
extern int delta_L=9;
extern int delta_S=10;
//extern double lot = 0.1;      // Qpx}u |p
extern int Orders=1;          // }p{y}p|~u {|yur t~ru}u~~ { xyyz
extern int MaxOpenTime=138;

int ticket,total,cnt;
bool cantrade=true;
double closeprice;
double tmp;

int OpenLong(double volume=0.1)
// ~{y {rpu t|y~~ xyy px}u} |p=volume 
{
  int slippage=10;
  string comment="20/200 expert v2 (Long)";
  color arrow_color=Red;
  int magic=0;

  ticket=OrderSend(Symbol(),OP_BUY,volume,Ask,slippage,Ask-StopLoss_L*Point,
                      Ask+TakeProfit_L*Point,comment,magic,0,arrow_color);
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
    {
      return(0);
    }
    else
      {
        Print("OpenLong(),OrderSelect() - rtp| yq{ : ",GetLastError());
        return(-1);
      }
  }
  else
  {
    Print("Error opening Buy order : ",GetLastError());
    return(-1);
  }
}

int OpenShort(double volume=0.1)
// ~{y {rpu {{ xyy px}u} |p=volume
{
  int slippage=10;
  string comment="20/200 expert v2 (Short)";
  color arrow_color=Red;
  int magic=0;

  ticket=OrderSend(Symbol(),OP_SELL,volume,Bid,slippage,Bid+StopLoss_S*Point,
                      Bid-TakeProfit_S*Point,comment,magic,0,arrow_color);
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
    else
      {
        Print("OpenShort(),OrderSelect() - rtp| yq{ : ",GetLastError());
        return(-1);
      }
  }
  else
  {
    Print("Error opening Sell order : ",GetLastError());
    return(-1);
  }
}

int init()
{
  return(0);
}

int deinit()
{
  return(0);
}

int start()
{
  if((TimeHour(TimeCurrent())>TradeTime)) cantrade=true;
  // ruu} u |y {u tup ...
  total=OrdersTotal();
  if(total<Orders)
  {
    // ... u|y ~u ~y t~s {s tup,  ytu} tp|u
    // ruu} ~pp| |y ru} t| sr|y
    if((TimeHour(TimeCurrent())==TradeTime)&&(cantrade))
    {
    
    double mantuka = AccountBalance() / 10000;
int baituka = mantuka * Leverage;
double lot = baituka * 0.1 ; 
if(lot<=0.1) lot=0.1;
if(lot>=1000) lot=1000;
    
    
      // ... u|y ~pp| ru}, 
      if (((Open[t1]-Open[t2])>delta_S*Point)) //E|y u~p }u~y|p ~p ru|yy~ delta
      {
        //|ryu r|~u~ x~py rty} r {{ xyy:
        // ruu} u |y rqt~u tu~sy t| {y {{z xyyy
        if(AccountFreeMarginCheck(Symbol(),OP_SELL,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenShort(lot);

        cantrade=false; //xpupu} srp r~ t |utus qpp
        return(0);
      }
      if (((Open[t2]-Open[t1])>delta_L*Point)) //E|y u~p yx}u~y|p ~p ru|yy~ delta
      {
        // |ryu r|~u~ x~py rty} r t|y~~ xyy
        // ruu} u |y rqt~u tu~sy ~p u
        if(AccountFreeMarginCheck(Symbol(),OP_BUY,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenLong(lot);
        cantrade=false;
        return(0);
      }
    }
  }
// q|{ ru{y ru}u~y wyx~y tu|{y, u|y MaxOpenTime=0,  ru{ ~u rty}.
  if(MaxOpenTime>0)
  {
    for(cnt=0;cnt<total;cnt++)
    {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
         tmp = (TimeCurrent()-OrderOpenTime())/3600.0;
         if (((NormalizeDouble(tmp,8)-MaxOpenTime)>=0))
        {
          RefreshRates();
          if (OrderType()==OP_BUY)
            closeprice=Bid;
          else
            closeprice=Ask;
          if (OrderClose(OrderTicket(),OrderLots(),closeprice,10,Green))
          {
            Print("Py~tyu|~u xp{yu tu|{y - ",OrderTicket());
            OrderPrint();
          }
          else
            Print("OrderClose() r q|{u ru{y ru}u~y wyx~y tu|{y ru~| yq{ - ",GetLastError());
        }
      }
      else
        Print("OrderSelect() r q|{u ru{y ru}u~y wyx~y tu|{y ru~| yq{ - ",GetLastError());
    }
  }
  return(0);
}


